%global luacompatver 5.1
%global luacompatpkgdir %{_datadir}/lua/%{luacompatver}
%global luacompatlibdir %{_libdir}/lua/%{luacompatver}
%global luacompatincdir %{_includedir}/lua-%{luacompatver}
%global lualib lua-%{luacompatver}

Summary:        Compatibility module providing Lua-5.3-style APIs for Lua %{luacompatver}
Name:           lua-compat53
Version:        0.12
Release:        2%{?dist}
License:        MIT
URL:            https://github.com/keplerproject/lua-compat-5.3
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  gcc pkgconfig compat-lua-devel

%description
This is a small module that aims to make it easier to write code in a Lua-5.3-style that is
compatible with Lua 5.1, Lua 5.2, and Lua 5.3. This does not make Lua 5.2 (or even Lua 5.1)
entirely compatible with Lua 5.3, but it brings the API closer to that of Lua 5.3.

%package -n     lua%{luacompatver}-compat53
Summary:        Compatibility module providing Lua-5.3-style APIs for Lua %{luacompatver}
Requires:       lua(abi) = %{luacompatver}

%description -n lua%{luacompatver}-compat53
This is a small module that aims to make it easier to write code in a Lua-5.3-style that is
compatible with Lua 5.1, Lua 5.2, and Lua 5.3. This does not make Lua 5.2 (or even Lua 5.1)
entirely compatible with Lua 5.3, but it brings the API closer to that of Lua 5.3.

%prep
%autosetup -n lua-compat-5.3-%{version} -p1

%build
CFLAGS="%{?optflags} -fPIC $(pkg-config --cflags %{lualib})"
LDFLAGS="%{?build_ldflags} $(pkg-config --libs %{lualib})"

gcc $CFLAGS -c lutf8lib.c -o lutf8lib.o
gcc $CFLAGS -c lstrlib.c -o lstrlib.o
gcc $CFLAGS -c ltablib.c -o ltablib.o
gcc -shared $LDFLAGS -o utf8.so lutf8lib.o
gcc -shared $LDFLAGS -o string.so lstrlib.o
gcc -shared $LDFLAGS -o table.so ltablib.o

%install
PKGDIR=%{buildroot}/%{luacompatpkgdir}
LIBDIR=%{buildroot}/%{luacompatlibdir}

install -d -m 0755 "$PKGDIR/compat53"
install -d -m 0755 "$LIBDIR/compat53"
install -p -m 0644 compat53/{init,module}.lua -t "$PKGDIR/compat53/"
install -p -m 0755 {utf8,string,table}.so -t "$LIBDIR/compat53/"

install -d -m 0755 %{buildroot}%{luacompatincdir}/c-api
install -m 0644 -p -t %{buildroot}%{luacompatincdir}/c-api c-api/*
install -m 0644 lprefix.h %{buildroot}%{luacompatincdir}/lprefix.h

%files -n lua%{luacompatver}-compat53
%license LICENSE
%doc README.md
%{luacompatpkgdir}/compat53
%{luacompatlibdir}/compat53
%{luacompatincdir}

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.12-2
- Rebuilt for loongarch release

* Thu Dec 21 2023 Upgrade Robot <upbot@opencloudos.org> - 0.12-1
- Upgrade to version 0.12

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.7-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.7-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.7-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Jan 16 2023 Shuo Wang <abushwang@tencent.com> - 0.7-1
- initial build
